
import StringIO
import sys
import string
import urllib
import socket
import select
import Image
import ImageTk
import ImageDraw
import MpVideo

class MpAxisVideo(MpVideo.MpVideo):
	def connect( self, url, resolution ):
		self.resolution.set(resolution)

		url = url + "&resolution=" + resolution + "&showlength=1"

		self.url_object = urllib.urlopen( url )

		fileno = self.url_object.fileno()

		self.socket = socket.fromfd( fileno, \
				socket.AF_INET, socket.SOCK_STREAM )

		self.my_boundary = self.url_object.readline()

	def get_image( self ):

		content_type_string = self.url_object.readline()

		content_length_string = self.url_object.readline()

		content_length_list = string.split( content_length_string )

		content_length = int( content_length_list[1] )

		blankline = self.url_object.readline()

		self.image_data = self.url_object.read( content_length )

		blankline2 = self.url_object.readline()

		blankline3 = self.url_object.readline()

		new_boundary = self.url_object.readline()

	def display_image( self ):

		image_string = StringIO.StringIO( self.image_data )

		self.photo = Image.open( image_string )

		self.x_max = self.photo.size[0]
		self.y_max = self.photo.size[1]

		width = self.cget("width")
		height = self.cget("height")

		if ( self.x_max != width ):
			self.configure( width=self.x_max )

		if ( self.y_max != height ):
			self.configure( height=self.y_max )

		if ( self.show_cursor ):
			# Draw a cursor on the image showing the goniostat
			# center position.

			cursor_x = self.x_max * self.x_center_fraction
			cursor_y = self.y_max * self.y_center_fraction

			draw_object = ImageDraw.Draw( self.photo )

			x_line = ( (cursor_x, 0), (cursor_x, self.y_max) )
			y_line = ( (0, cursor_y), (self.x_max, cursor_y) )

#			print "x_line =", x_line
#			print "y_line =", y_line

			color = (255,0,0)

			draw_object.line( x_line, fill = color )
			draw_object.line( y_line, fill = color )

		# Copy the image to the screen.

		self.photoimage = ImageTk.PhotoImage( self.photo )

		self.image = self.create_image( 0, 0, \
				anchor="nw", image = self.photoimage)

		self.pack()

		self.update()

	def image_is_available( self ):

		read_list = [ self.socket ]

		select_list = select.select( read_list, [], [], 0 )

		readable_list = select_list[0]

		read_status = len(readable_list)

		return read_status

